*-- cust6.prg 
*-- Customer Directory
*-- (End each group on an EVEN page)
*--
*-- Forcing a Group to End on an Even Page

* Open File
SELECT 0
USE customer

* Create Temporary Cursor
PRIVATE cCursor
cCursor = SYS(3)
SELECT *, ;
   ' ' AS blnkpage, ;
   0000 AS pageno ;
   FROM customer ;
   INTO TABLE &cCursor 
INDEX ON comp_name + blnkpage TAG SortOrder

* Initialize variables
PRIVATE nPageNo, bProcessing, cTemp
nPageNo = 0
bProcessing = .t.
cTemp = SUBSTR(SYS(2015), 3, 10) + '.txt'

* Process the report
IF 'VISUAL' $ UPPER(VERSION())
  REPORT FORM vfpcust6 NOCONSOLE TO FILE &cTEMP
ELSE
  REPORT FORM fp2cust6 NOCONSOLE TO FILE &cTEMP
ENDIF
ERASE (cTemp)
bProcessing = .f.
WAIT CLEAR

* Preview/Print the report
IF 'VISUAL' $ UPPER(VERSION())
  REPORT FORM vfpcust6 TO PRINTER PROMPT PREVIEW
ELSE
  REPORT FORM fp2cust6 PREVIEW
ENDIF

* Close files
USE
ERASE (cCURSOR + '.DBF')
ERASE (cCURSOR + '.CDX')
SELECT customer
USE

******************
PROCEDURE BlnkPage
******************
* If this page isn't even, force a 
* blank page after this group

IF bProcessing AND MOD(_PAGENO,2) <> 0 AND ;
   blnkpage <> 'Y'
  SCATTER MEMVAR BLANK
  m.comp_name = comp_name
  m.blnkpage = 'Y'
  APPEND BLANK
  GATHER MEMVAR 
ENDIF
RETURN ''

******************
PROCEDURE IncrPage
******************
* Increase the page number and store
* with this record

IF NOT bProcessing AND pageno = 0
  nPageNo = nPageNo + 1
  REPLACE pageno WITH nPageNo
ENDIF
RETURN ''
