**********************************************************************
* Program....: PathSet.prg
* Compiler...: Visual FoxPro 06.00.8862.00 for Windows
* Abstract...: Method Code for changing Data Path at run time
* Written By.: Andy Kramek, Tightline Computers Ltd, August 2000
**********************************************************************
LPARAMETERS tcDataPath, tcDataBase
LOCAL ARRAY laObj[1]
LOCAL lnObjCnt, lnCnt, loObj, lcTable, lcDBC
IF EMPTY( tcDatabase ) AND ! PEMSTATUS( _Screen, 'cDataBase', 5 )
    *** No parameters & Property does NOT exist!
    *** Something is badly wrong
    ASSERT .F. MESSAGE "cDatabase Property not found on _Screen" )
    RETURN .F.
ENDIF
*** Use Parameters if passed, otherwise property
lcDataPath = IIF( ! EMPTY( tcDataPath ), tcDataPath, _Screen.cDataPath  )
lcDataBase = IIF( ! EMPTY( tcDataBase ), tcDataBase, _Screen.cDataBase  )
*** Close any open tables
WITH This.DataEnvironment
    IF .AutoOpenTables
        .CloseTables()
    ENDIF
ENDWITH
*** Get a list of all objects in the DE
lnObjCnt = AMEMBERS( laObj, ThisForm.DataEnvironment, 2)
*** Scan the list
FOR lnCnt = 1 TO lnObjCnt
  *** Check if this object is actually a Cursor
  loObj = EVAL( "ThisForm.DataEnvironment." + laObj[lnCnt] )
  IF NOT ( loObj.BaseClass = "Cursor" )
    *** Not a Cursor - ignore it
    LOOP
  ENDIF
  *** We have a cursor
  IF EMPTY( loObj.DataBase )
    *** This is a Free Table, get the file name
    lcTable = JUSTFNAME( loObj.CursorSource )
    *** Add the correct path
    loObj.CursorSource = ADDBS( lcDataPath ) + lcTable
  ELSE
    *** We have a bound table, set the DBC
    lcDBC = lcDataBase
    loObj.Database = ADDBS( lcDataPath ) + lcDBC
  ENDIF
NEXT
*** Re-Open the tables from new location
This.DataEnvironment.OpenTables()
RETURN
